/*
PPKMouseAddon
 by Mnjul/purincess (Min-Zhong Lu)
 # Middle Sea, Mnjul's Intimate Home

Copyright 2007-2010 Min-Zhong Lu

This file is part of PPKMouseAddon.

PPKMouseAddon is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

PPKMouseAddon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with PPKMouseAddon.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "stdafx.h"
#include "AboutDlg.h"
#include "ApplicationUtility.h"

#include "resource.h"

#include <sstream>

BOOL AboutDlg::OnInitDialog(){
	try{
		const wchar_t* filename = L"msimg32.dll";
		int verInfoSize = GetFileVersionInfoSize(filename,NULL);
		if(verInfoSize != 0){
			void* pVerDataBuffer = static_cast<void*>(new char[verInfoSize]);

			if(pVerDataBuffer){
				GetFileVersionInfo(filename, NULL, verInfoSize, pVerDataBuffer);
				VS_FIXEDFILEINFO* vsFixedInfo;
				VerQueryValue(pVerDataBuffer, L"\\", reinterpret_cast<LPVOID*>(&vsFixedInfo), NULL);
				std::wostringstream verString;
				verString << L"Ver. " << HIWORD(vsFixedInfo->dwFileVersionMS) << L"." << LOWORD(vsFixedInfo->dwFileVersionMS) << L"." << HIWORD(vsFixedInfo->dwFileVersionLS) << L"." << LOWORD(vsFixedInfo->dwFileVersionLS);
				this->SetDlgItemText(IDC_ABOUT_STATIC_VERSION, verString.str().c_str());

				delete [] pVerDataBuffer;
			}
		}
		return TRUE;
	}catch(unsigned int errCode){
		ApplicationUtility::getInstance().showTypeSafeErrorMessage(errCode, L"AboutDlg::OnInitDialog");
	}
	return FALSE;
}