/*
PPKMouseAddon
 by Mnjul/purincess (Min-Zhong Lu)
 # Middle Sea, Mnjul's Intimate Home

Copyright 2007-2010 Min-Zhong Lu

This file is part of PPKMouseAddon.

PPKMouseAddon is free software: you can redistribute it and/or modify
it under the terms of the GNU Lesser General Public License as published by
the Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

PPKMouseAddon is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
License for more details.

You should have received a copy of the GNU Lesser General Public License
along with PPKMouseAddon.  If not, see <http://www.gnu.org/licenses/>.
*/

#include "stdafx.h"
#include "OptionsDlg.h"
#include "Settings.h"

#include "resource.h"

BOOL OptionsDlg::OnInitDialog(){
	setCmbButtonWheelScrollText(IDC_OPTIONS_COMBO_LEFT_WHEEL_SCROLL);
	setCmbButtonWheelScrollText(IDC_OPTIONS_COMBO_RIGHT_WHEEL_SCROLL);

	CheckDlgButton(IDC_OPTIONS_CHECK_ENABLEMOUSELEFT, Settings::getInstance().enabledMouseLeft ? BST_CHECKED : BST_UNCHECKED);
	CheckDlgButton(IDC_OPTIONS_CHECK_ENABLEMOUSERIGHT, Settings::getInstance().enabledMouseRight ? BST_CHECKED : BST_UNCHECKED);
	CheckDlgButton(IDC_OPTIONS_CHECK_ENABLEMOUSEMIDDLE, Settings::getInstance().enabledMouseMiddle ? BST_CHECKED : BST_UNCHECKED);
	CheckDlgButton(IDC_OPTIONS_CHECK_ENABLEMOUSEWHEEL, Settings::getInstance().enabledMouseWheel ? BST_CHECKED : BST_UNCHECKED);
	if(Settings::getInstance().lrrl == Settings::LR_TO_RL){
		CheckDlgButton(IDC_OPTIONS_OPT_LRMAP_LRRL, BST_CHECKED);
	}else{
		CheckDlgButton(IDC_OPTIONS_OPT_LRMAP_LLRR, BST_CHECKED);
	}
	setLRMapText();

	setComboBoxCurSel(IDC_OPTIONS_COMBO_LEFT_WHEEL_SCROLL, Settings::getInstance().keypairLeftButtonWheelScroll);
	setComboBoxCurSel(IDC_OPTIONS_COMBO_RIGHT_WHEEL_SCROLL, Settings::getInstance().keypairRightButtonWheelScroll);

	setHotkeyHotKey(IDC_OPTIONS_HOTKEY_LEFT_RIGHT, Settings::getInstance().hkLR.vkeyCode, Settings::getInstance().hkLR.modifiers);
	setHotkeyHotKey(IDC_OPTIONS_HOTKEY_LEFT_WHEEL, Settings::getInstance().hkLW.vkeyCode, Settings::getInstance().hkLW.modifiers);
	setHotkeyHotKey(IDC_OPTIONS_HOTKEY_RIGHT_LEFT, Settings::getInstance().hkRL.vkeyCode, Settings::getInstance().hkRL.modifiers);
	setHotkeyHotKey(IDC_OPTIONS_HOTKEY_RIGHT_WHEEL, Settings::getInstance().hkRW.vkeyCode, Settings::getInstance().hkRW.modifiers);
	setHotkeyHotKey(IDC_OPTIONS_HOTKEY_WHEEL_LEFT, Settings::getInstance().hkWL.vkeyCode, Settings::getInstance().hkWL.modifiers);
	setHotkeyHotKey(IDC_OPTIONS_HOTKEY_WHEEL_RIGHT, Settings::getInstance().hkWR.vkeyCode, Settings::getInstance().hkWR.modifiers);

	return TRUE;
}

BOOL OptionsDlg::OnCommand(WPARAM wparam, LPARAM lparam){
	switch(LOWORD(wparam)){
		case IDC_OPTIONS_OPT_LRMAP_LRRL:
		case IDC_OPTIONS_OPT_LRMAP_LLRR:
			if(HIWORD(wparam) == BN_CLICKED){
				onOptLRMapClicked();
				return TRUE;
			}
			break;
	}
	return FALSE;
}

void OptionsDlg::OnOK(){
	Settings::getInstance().enabledMouseLeft = isButtonChecked(IDC_OPTIONS_CHECK_ENABLEMOUSELEFT) == BST_CHECKED;
	Settings::getInstance().enabledMouseRight = isButtonChecked(IDC_OPTIONS_CHECK_ENABLEMOUSERIGHT) ==BST_CHECKED;
	Settings::getInstance().enabledMouseMiddle = isButtonChecked(IDC_OPTIONS_CHECK_ENABLEMOUSEMIDDLE) ==BST_CHECKED;
	Settings::getInstance().enabledMouseWheel = isButtonChecked(IDC_OPTIONS_CHECK_ENABLEMOUSEWHEEL) ==BST_CHECKED;
	Settings::getInstance().lrrl = (isButtonChecked(IDC_OPTIONS_OPT_LRMAP_LRRL) == BST_CHECKED) ? Settings::LR_TO_RL : Settings::LR_TO_LR;
	Settings::getInstance().keypairLeftButtonWheelScroll = static_cast<Settings::ButtonWheelScrollKeyPair>(getComboBoxCurSel(IDC_OPTIONS_COMBO_LEFT_WHEEL_SCROLL));
	Settings::getInstance().keypairRightButtonWheelScroll = static_cast<Settings::ButtonWheelScrollKeyPair>(getComboBoxCurSel(IDC_OPTIONS_COMBO_RIGHT_WHEEL_SCROLL));

	getHotkeyHotKey(IDC_OPTIONS_HOTKEY_LEFT_RIGHT, &(Settings::getInstance().hkLR.vkeyCode), &(Settings::getInstance().hkLR.modifiers));
	getHotkeyHotKey(IDC_OPTIONS_HOTKEY_LEFT_WHEEL, &(Settings::getInstance().hkLR.vkeyCode), &(Settings::getInstance().hkLR.modifiers));
	getHotkeyHotKey(IDC_OPTIONS_HOTKEY_RIGHT_LEFT, &(Settings::getInstance().hkLW.vkeyCode), &(Settings::getInstance().hkLW.modifiers));
	getHotkeyHotKey(IDC_OPTIONS_HOTKEY_RIGHT_WHEEL, &(Settings::getInstance().hkRL.vkeyCode), &(Settings::getInstance().hkRL.modifiers));
	getHotkeyHotKey(IDC_OPTIONS_HOTKEY_WHEEL_LEFT, &(Settings::getInstance().hkRW.vkeyCode), &(Settings::getInstance().hkRW.modifiers));
	getHotkeyHotKey(IDC_OPTIONS_HOTKEY_WHEEL_RIGHT, &(Settings::getInstance().hkWL.vkeyCode), &(Settings::getInstance().hkWL.modifiers));


	CDialog::OnOK();
}

void OptionsDlg::onOptLRMapClicked(){
	setLRMapText();
}

inline UINT OptionsDlg::isButtonChecked(int idButton) const{
	return ::IsDlgButtonChecked(this->m_hWnd, idButton);
}

inline LRESULT OptionsDlg::setComboBoxCurSel(int idComboBox, int sel){
	return SendDlgItemMessage(idComboBox, CB_SETCURSEL, sel, 0); 
}

inline int OptionsDlg::getComboBoxCurSel(int idComboBox) const{
	return SendDlgItemMessage(idComboBox, CB_GETCURSEL, 0, 0); 
}

inline void OptionsDlg::setHotkeyHotKey(int idHotkey, WORD vKeyCode, WORD modifiers){
	SendDlgItemMessage(idHotkey, HKM_SETHOTKEY, MAKEWPARAM(MAKEWORD(vKeyCode, modifiers), 0), 0);
}

inline void OptionsDlg::getHotkeyHotKey(int idHotkey, WORD* vKeyCode, WORD* modifiers) const{
	LRESULT result = SendDlgItemMessage(idHotkey, HKM_GETHOTKEY, 0, 0);
	*vKeyCode = LOBYTE(LOWORD(result));
	*modifiers = HIBYTE(LOWORD(result));
}

inline void OptionsDlg::setLRMapText(){
	if(isButtonChecked(IDC_OPTIONS_OPT_LRMAP_LRRL) == BST_CHECKED){
		SetDlgItemText(IDC_OPTIONS_CHECK_ENABLEMOUSELEFT, L"ҥηƹ@Vk");
		SetDlgItemText(IDC_OPTIONS_CHECK_ENABLEMOUSERIGHT, L"ҥηƹk@V");
	}else{
		SetDlgItemText(IDC_OPTIONS_CHECK_ENABLEMOUSELEFT, L"ҥηƹ@V");
		SetDlgItemText(IDC_OPTIONS_CHECK_ENABLEMOUSERIGHT, L"ҥηƹk@Vk");
	}
}

inline void OptionsDlg::setCmbButtonWheelScrollText(const int idCMB){
	SendDlgItemMessage(idCMB, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>(L"(VW/VU)"));
	SendDlgItemMessage(idCMB, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>(L"Page Up M Page Down/Space"));
	SendDlgItemMessage(idCMB, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>(L"[ M ] (PD\ŪW@g/U@g峹)"));
	SendDlgItemMessage(idCMB, CB_ADDSTRING, 0, reinterpret_cast<LPARAM>(L"b M f (\Ū峹ɤW@g/U@g峹)"));
}